


import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.ruleflow.core.RuleFlowProcessFactory;



/**
 * This is a sample file to launch a process.
 */
public class MultiLoopProcessTest {

	public static final void main(String[] args) {
		try {
			// load up the knowledge base
			
			KnowledgeBase kbase = readKnowledgeBase();
			StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
			
			//KnowledgeRuntimeLoggerFactory.newConsoleLogger(ksession);
			
			File logFile = File.createTempFile("test.log","");
			System.out.println("Log file= "+logFile.getAbsolutePath()+".log");
			KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession,logFile.getAbsolutePath());
			Map<String, Object> params = new HashMap<String, Object>();
			List<Integer> myList = new ArrayList<Integer>();
			Random r = new Random();
			myList.add(5);
			myList.add(2);
			myList.add(1);
			myList.add(3);
			myList.add(4);

			params.put("list", myList);
			// start a new process instance
			ksession.startProcess("mainprocess",params);
			logger.close();
		} catch (Throwable t) {
			System.out.println("Got en exception ");
		}
	}
	

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("mainprocess.bpmn"), ResourceType.BPMN2);
		kbuilder.add(ResourceFactory.newClassPathResource("bookdownloadprocess.bpmn"),
				ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}
	
}